var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Clock = function () {
  function Clock(target) {
    var interval = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1000;

    _classCallCheck(this, Clock);

    this.$el = $(target);
    this.interval = interval;
    this._init();
  }

  _createClass(Clock, [{
    key: '_init',
    value: function _init() {
      if (this.initialized) return this;
      this.$el.append(this.hands.second);
      this.$el.append(this.hands.minute);
      this.$el.append(this.hands.hour);
      this.start();
      this.initialized = true;
    }
  }, {
    key: 'start',
    value: function start() {
      if (!this.isRunning) {
        this._intervalId = setInterval(this._tick.bind(this), this.interval);
        this._tick();
      }
      return this;
    }
  }, {
    key: 'stop',
    value: function stop() {
      if (this.isRunning) {
        window.clearInterval(this._intervalId);
        this._intervalId = null;
      }
      return this;
    }
  }, {
    key: '_tick',
    value: function _tick() {
      var t = new Date();
      var sdegree = t.getSeconds() * 6;
      var mdegree = t.getMinutes() * 6;
      var hdegree = t.getHours() * 30 + t.getMinutes() / 2;

      this.hands.second.css({
        transform: 'rotate(' + sdegree + 'deg)'
      });

      this.hands.minute.css({
        transform: 'rotate(' + mdegree + 'deg)'
      });

      this.hands.hour.css({
        transform: 'rotate(' + hdegree + 'deg)'
      });
    }
  }, {
    key: 'isRunning',
    get: function get() {
      return this._intervalId && this._intervalId !== null;
    }
  }, {
    key: 'hands',
    get: function get() {
      if (!this._secondHand) {
        this._secondHand = $('<div class="hand second-hand"></div>');
      }
      if (!this._minuteHand) {
        this._minuteHand = $('<div class="hand minute-hand"></div>');
      }
      if (!this._hourHand) {
        this._hourHand = $('<div class="hand hour-hand"></div>');
      }
      return {
        second: this._secondHand,
        minute: this._minuteHand,
        hour: this._hourHand
      };
    }
  }]);

  return Clock;
}();

var c = new Clock(document.getElementById('clock'));