var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Clock = function () {
  function Clock(id) {
    _classCallCheck(this, Clock);

    this.timezone = parseInt(document.getElementById(id).dataset.timezone);

    if (this.isDST(new Date())) {
      this.timezone += 1;
    }

    this.handSeconds = document.querySelector("#" + id + " .hand.seconds");
    this.handMinutes = document.querySelector("#" + id + " .hand.minutes");
    this.handHours = document.querySelector("#" + id + " .hand.hours");

    this.getTime();
    this.cycle();
  }

  _createClass(Clock, [{
    key: "isDST",
    value: function isDST(now) {
      var jan = new Date(now.getFullYear(), 0, 1);
      var jul = new Date(now.getFullYear(), 6, 1);
      var dst = Math.max(jan.getTimezoneOffset(), jul.getTimezoneOffset());

      return now.getTimezoneOffset() < dst;
    }
  }, {
    key: "draw",
    value: function draw(hours, minutes, seconds) {
      var drawSeconds = seconds / 60 * 360 + 90;
      var drawMinutes = minutes / 60 * 360 + 90;

      if (hours >= 12) {
        drawHours = hours - 12;
      }

      var drawHours = hours / 12 * 360 + 90;

      this.handSeconds.style.transform = "rotate(" + drawSeconds + "deg)";
      this.handMinutes.style.transform = "rotate(" + drawMinutes + "deg)";
      this.handHours.style.transform = "rotate(" + drawHours + "deg)";

      // fix for animation bump on when clock hands hit zero
      if (drawSeconds === 444 || drawSeconds === 90) {
        this.handSeconds.style.transition = "all 0s ease 0s";
      } else {
        this.handSeconds.style.transition = "all 0.05s cubic-bezier(0, 0, 0.52, 2.51) 0s";
      }
    }
  }, {
    key: "getTime",
    value: function getTime() {
      var now = new Date();

      var hours = now.getUTCHours() + this.timezone;
      var minutes = now.getUTCMinutes();
      var seconds = now.getUTCSeconds();

      this.draw(hours, minutes, seconds);
    }
  }, {
    key: "cycle",
    value: function cycle() {
      setInterval(this.getTime.bind(this), 1000);
    }
  }]);

  return Clock;
}();

new Clock('okinawa');
new Clock('seattle');
new Clock('amalfi');

// this is just a rough draft for some effects
// const shadowOkinawa = document.querySelector("#okinawa .shadow");
// const shadowSeattle = document.querySelector("#seattle .shadow");
// const shadowAmalfi = document.querySelector("#amalfi .shadow");

// const handleMouseMove = (event) => {
//   const percent = parseInt((100 * event.pageX) / window.innerWidth);
//   const drawShadow = (0.22 * percent) - 50;

//   shadowOkinawa.style.transform = `rotate(${drawShadow}deg)`;
//   shadowSeattle.style.transform = `rotate(${drawShadow}deg)`;
//   shadowAmalfi.style.transform = `rotate(${drawShadow}deg)`;
// };

// document.onmousemove = handleMouseMove;